- name: Install dependencies
  ansible.builtin.apt:
    pkg:
      - cron
    state: present
    update_cache: true

- name: Ensure temporary folder exists
  ansible.builtin.file:
    path: "/tmp/krew"
    state: directory
    mode: "0755"

- name: Download Krew
  ansible.builtin.unarchive:
    src: "https://github.com/kubernetes-sigs/krew/releases/latest/download/krew-linux_amd64.tar.gz"
    dest: "/tmp/krew"
    mode: "0755"
    remote_src: true

- name: Install Krew
  ansible.builtin.command: /tmp/krew/krew-linux_amd64 install krew
  changed_when: true

- name: Add check plugin repo
  ansible.builtin.command: "{{ k8s_compute_exporter_krew_install_dir }}/kubectl-krew index add regateiro https://gitlab.com/diogoregateiro/krew-index.git"
  become: true
  changed_when: true
  failed_when: false

- name: Install check plugin
  ansible.builtin.command: "{{ k8s_compute_exporter_krew_install_dir }}/kubectl-krew install regateiro/check"
  become: true
  changed_when: true

- name: Copy create_k8s_compute to /usr/local/bin
  ansible.builtin.template:
    src: "create_k8s_compute_metrics.sh.j2"
    dest: "/usr/local/bin/create_k8s_compute_metrics.sh"
    mode: '0755'
  become: true

- name: Add cron job
  ansible.builtin.cron:
    name: generate k8s compute metrics
    minute: "{{ k8s_compute_exporter_schedule.minute }}"
    hour: "{{ k8s_compute_exporter_schedule.hour }}"
    day: "{{ k8s_compute_exporter_schedule.day }}"
    month: "{{ k8s_compute_exporter_schedule.month }}"
    weekday: "{{ k8s_compute_exporter_schedule.weekday }}"
    job: /usr/local/bin/create_k8s_compute_metrics.sh
    user: root
    cron_file: k8s-compute-exporter-metrics
  become: true
